!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #################################################################################
SUBROUTINE DEALLOC_ISBA_n
!     #################################################################################
!
!!****  *DEALLOC_ISBA_n * - Deallocate all arrays
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     V. Masson 
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!------------------------------------------------------------------
!

!
USE MODD_ISBA_n,      ONLY : LCOVER, XCOVER, XZS, XZ0EFFJPDIR, XCLAY, XSAND,       &
                               XSOC, XRUNOFFB,                                     &
                               XAOSIP, XAOSIM, XAOSJP, XAOSJM,                     &
                               XHO2IP, XHO2IM, XHO2JP, XHO2JM,                     &
                               XZ0EFFIP, XZ0EFFIM, XZ0EFFJP, XZ0EFFJM,             &
                               XZ0REL, XSSO_SLOPE,                                 &
                               XWWILT, XWFC, XWSAT,                                &
                               XVEG, XLAI, XRSMIN, XGAMMA, XRGL, XCV,              &
                               XDG, NWG_LAYER, XDROOT, XDG2, XDZG, XDZDIF,         &
                               XZ0, XZ0_O_Z0H,                                     &
                               XALBNIR_VEG, XALBVIS_VEG, XALBUV_VEG,               &
                               XEMIS, XVEGTYPE, XGMES, XRE25, XBSLAI, XLAIMIN, XGC,&
                               XDMAX, LSTRESS, XF2I,                               &
                               XSEFOLD, XH_TREE, XPATCH, NPATCH, XWRMAX_CF,        &
                               NR_NATURE_P, NSIZE_NATURE_P,NPATCH,                 &
                               XALBNIR_DRY, XALBVIS_DRY, XALBUV_DRY,               &
                               XALBNIR_WET, XALBVIS_WET, XALBUV_WET,               &
                               XALBNIR_SOIL, XALBVIS_SOIL, XALBUV_SOIL,            &
                               XWG, XTG, TSNOW, XALBNIR, XALBVIS, XALBUV,          &
                               XEMIS_NAT, XTSRAD_NAT,                              &
                               XVEGTYPE_PATCH,XROOTFRAC,XRUNOFFD,XSOILWGHT,        &
                               XCGSAT, XC1SAT, XC2REF, XC3, XC4B, XACOEF, XPCOEF,  &
                               XTAUICE, XACOEF, XBCOEF, XCONDSAT,                  &
                               XHCAPSOIL, XCONDDRY, XCONDSLD, XC4REF, XMPOTSAT,    &
                               XTDEEP, XGAMMAT, XWDRAIN,                           &
                               XCE_NITRO, XCF_NITRO, XCNA_NITRO, XBSLAI_NITRO,     &
                               XTI_MIN,XTI_MAX,XTI_MEAN,XTI_STD,XTI_SKEW,XTAB_FSAT,&
                               XTAB_WTOP,XD_ICE,XKSAT_ICE,XMUF,XFSAT,              &
                               XFFLOOD, XPIFLOOD, XZ0_FLOOD,                       &
                               XPSNG,XPSNV,XPSNV_A,XPSN,XDIR_ALB_WITH_SNOW,        &
                               XSCA_ALB_WITH_SNOW,XFFG,XFFV,XFF,XALBF,XEMISF,      &
                               XCPL_EFLOOD,XCPL_PFLOOD,XCPL_IFLOOD,XCPL_DRAIN,     &
                               XCPL_RUNOFF, XCPL_ICEFLUX, XICE_STO, XFFROZEN,      &
                               XDG_OLD,XPATCH_OLD,XABC,XPOI,XFRACSOC

USE MODD_DATA_ISBA_n,    ONLY : XPAR_VEGTYPE,  XPAR_LAI, XPAR_H_TREE, XPAR_DG, &
                                XPAR_ROOTFRAC, XPAR_VEG, XPAR_Z0, XPAR_EMIS, XPAR_DICE, &
                                XPAR_RSMIN, XPAR_GAMMA, XPAR_WRMAX_CF, XPAR_RGL, &
                                XPAR_CV, XPAR_Z0_O_Z0H, &
                                XPAR_ALBNIR_VEG, XPAR_ALBVIS_VEG, XPAR_ALBUV_VEG,      &
                                XPAR_ALBNIR_SOIL, XPAR_ALBVIS_SOIL, XPAR_ALBUV_SOIL,   &
                                XPAR_GMES, XPAR_BSLAI, XPAR_SEFOLD, XPAR_GC, XPAR_DMAX, &
                                XPAR_RE25, XPAR_LAIMIN, XPAR_F2I,  &
                                XPAR_CE_NITRO,XPAR_CF_NITRO,XPAR_CNA_NITRO, &
                                LPAR_STRESS, XPAR_IRRIG, XPAR_WATSUP                               
!                             
USE MODD_ISBA_GRID_n, ONLY : XGRID_PAR, XLAT, XLON, XMESH_SIZE
USE MODD_GR_BIOG_n,   ONLY : XISOPOT, XMONOPOT
USE MODD_CH_ISBA_n,   ONLY : XDEP, CCH_NAMES, CSV
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*      0.1    declarations of arguments
!
!
!*      0.2    declarations of local variables
!
!-------------------------------------------------------------------------------------
!

REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('DEALLOC_ISBA_N',0,ZHOOK_HANDLE)
IF (ASSOCIATED(LCOVER     )) DEALLOCATE(LCOVER )
IF (ASSOCIATED(XCOVER     )) DEALLOCATE(XCOVER )
IF (ASSOCIATED(XZS        )) DEALLOCATE(XZS    )
IF (ASSOCIATED(XZ0EFFJPDIR)) DEALLOCATE(XZ0EFFJPDIR)
IF (ASSOCIATED(XCLAY      )) DEALLOCATE(XCLAY  )
IF (ASSOCIATED(XSAND      )) DEALLOCATE(XSAND  )
IF (ASSOCIATED(XSOC       )) DEALLOCATE(XSOC   )
IF (ASSOCIATED(XRUNOFFB   )) DEALLOCATE(XRUNOFFB)
!
IF (ASSOCIATED(XAOSIP))     DEALLOCATE( XAOSIP)
IF (ASSOCIATED(XAOSIM))     DEALLOCATE( XAOSIM)
IF (ASSOCIATED(XAOSJP))     DEALLOCATE( XAOSJP)
IF (ASSOCIATED(XAOSJM))     DEALLOCATE( XAOSJM)
IF (ASSOCIATED(XHO2IP))     DEALLOCATE( XHO2IP)
IF (ASSOCIATED(XHO2IM))     DEALLOCATE( XHO2IM)
IF (ASSOCIATED(XHO2JP))     DEALLOCATE( XHO2JP)
IF (ASSOCIATED(XHO2JM))     DEALLOCATE( XHO2JM)
IF (ASSOCIATED(XZ0EFFIP))   DEALLOCATE( XZ0EFFIP)
IF (ASSOCIATED(XZ0EFFIM))   DEALLOCATE( XZ0EFFIM)
IF (ASSOCIATED(XZ0EFFJP))   DEALLOCATE( XZ0EFFJP)
IF (ASSOCIATED(XZ0EFFJM))   DEALLOCATE( XZ0EFFJM)
IF (ASSOCIATED(XZ0REL))     DEALLOCATE( XZ0REL)
IF (ASSOCIATED(XSSO_SLOPE)) DEALLOCATE( XSSO_SLOPE)
!
!-------------------------------------------------------------------------------------
!
IF (ASSOCIATED(XGRID_PAR )) DEALLOCATE(XGRID_PAR )
IF (ASSOCIATED(XLAT      )) DEALLOCATE(XLAT      )
IF (ASSOCIATED(XLON      )) DEALLOCATE(XLON      )
IF (ASSOCIATED(XMESH_SIZE)) DEALLOCATE(XMESH_SIZE)
!
!-------------------------------------------------------------------------------------
!
IF (ASSOCIATED(XMONOPOT)) DEALLOCATE(XMONOPOT)
IF (ASSOCIATED(XISOPOT))  DEALLOCATE(XISOPOT)
!
!-------------------------------------------------------------------------------------
!
IF (ASSOCIATED(XLAI       )) DEALLOCATE(XLAI       )
IF (ASSOCIATED(XVEG       )) DEALLOCATE(XVEG       )
IF (ASSOCIATED(XRSMIN     )) DEALLOCATE(XRSMIN     )
IF (ASSOCIATED(XGAMMA     )) DEALLOCATE(XGAMMA     )
IF (ASSOCIATED(XWRMAX_CF  )) DEALLOCATE(XWRMAX_CF  )
IF (ASSOCIATED(XRGL       )) DEALLOCATE(XRGL       )
IF (ASSOCIATED(XCV        )) DEALLOCATE(XCV        )
IF (ASSOCIATED(XDG        )) DEALLOCATE(XDG        )
IF (ASSOCIATED(XDZG       )) DEALLOCATE(XDZG       )
IF (ASSOCIATED(XDZDIF     )) DEALLOCATE(XDZDIF     )
IF (ASSOCIATED(XDG_OLD    )) DEALLOCATE(XDG_OLD    )
IF (ASSOCIATED(NWG_LAYER  )) DEALLOCATE(NWG_LAYER  )
IF (ASSOCIATED(XDROOT     )) DEALLOCATE(XDROOT     )
IF (ASSOCIATED(XDG2       )) DEALLOCATE(XDG2       )
IF (ASSOCIATED(XROOTFRAC  )) DEALLOCATE(XROOTFRAC  )
IF (ASSOCIATED(XZ0        )) DEALLOCATE(XZ0        )
IF (ASSOCIATED(XZ0_O_Z0H  )) DEALLOCATE(XZ0_O_Z0H  )
IF (ASSOCIATED(XALBNIR_VEG)) DEALLOCATE(XALBNIR_VEG)
IF (ASSOCIATED(XALBVIS_VEG)) DEALLOCATE(XALBVIS_VEG)
IF (ASSOCIATED(XALBUV_VEG )) DEALLOCATE(XALBUV_VEG )
IF (ASSOCIATED(XEMIS      )) DEALLOCATE(XEMIS      )
IF (ASSOCIATED(XVEGTYPE   )) DEALLOCATE(XVEGTYPE   )
IF (ASSOCIATED(XGMES      )) DEALLOCATE(XGMES      )
IF (ASSOCIATED(XRE25      )) DEALLOCATE(XRE25      )
IF (ASSOCIATED(XBSLAI     )) DEALLOCATE(XBSLAI     )
IF (ASSOCIATED(XLAIMIN    )) DEALLOCATE(XLAIMIN    )
IF (ASSOCIATED(XSEFOLD    )) DEALLOCATE(XSEFOLD    )
IF (ASSOCIATED(XGC        )) DEALLOCATE(XGC        )
IF (ASSOCIATED(XDMAX      )) DEALLOCATE(XDMAX      )
IF (ASSOCIATED(XF2I       )) DEALLOCATE(XF2I       )
IF (ASSOCIATED(LSTRESS    )) DEALLOCATE(LSTRESS    )
IF (ASSOCIATED(XH_TREE    )) DEALLOCATE(XH_TREE    )
IF (ASSOCIATED(XCE_NITRO  )) DEALLOCATE(XCE_NITRO  )
IF (ASSOCIATED(XCF_NITRO  )) DEALLOCATE(XCF_NITRO  )
IF (ASSOCIATED(XCNA_NITRO )) DEALLOCATE(XCNA_NITRO )
IF (ASSOCIATED(XBSLAI_NITRO)) DEALLOCATE(XBSLAI_NITRO)
IF (ASSOCIATED(XPATCH        )) DEALLOCATE(XPATCH        )
IF (ASSOCIATED(XVEGTYPE_PATCH)) DEALLOCATE(XVEGTYPE_PATCH)
IF (ASSOCIATED(XPATCH_OLD  )) DEALLOCATE(XPATCH_OLD  )
IF (ASSOCIATED(NSIZE_NATURE_P)) DEALLOCATE(NSIZE_NATURE_P)
IF (ASSOCIATED(NR_NATURE_P)) DEALLOCATE(NR_NATURE_P)
IF (ASSOCIATED(XWDRAIN)) DEALLOCATE(XWDRAIN)
IF (ASSOCIATED(XTDEEP )) DEALLOCATE(XTDEEP )
IF (ASSOCIATED(XGAMMAT)) DEALLOCATE(XGAMMAT)
IF (ASSOCIATED(XWWILT)) DEALLOCATE(XWWILT)
IF (ASSOCIATED(XWFC  )) DEALLOCATE(XWFC  )
IF (ASSOCIATED(XWSAT )) DEALLOCATE(XWSAT )
IF (ASSOCIATED(XTAUICE)) DEALLOCATE(XTAUICE)
IF (ASSOCIATED(XBCOEF)) DEALLOCATE(XBCOEF)
IF (ASSOCIATED(XRUNOFFD)) DEALLOCATE(XRUNOFFD)
IF (ASSOCIATED(XSOILWGHT)) DEALLOCATE(XSOILWGHT)
IF (ASSOCIATED(XHCAPSOIL)) DEALLOCATE(XHCAPSOIL)
IF (ASSOCIATED(XCONDDRY )) DEALLOCATE(XCONDDRY )
IF (ASSOCIATED(XCONDSLD )) DEALLOCATE(XCONDSLD )
IF (ASSOCIATED(XCGSAT )) DEALLOCATE(XCGSAT )
IF (ASSOCIATED(XC1SAT)) DEALLOCATE(XC1SAT)
IF (ASSOCIATED(XC2REF)) DEALLOCATE(XC2REF)
IF (ASSOCIATED(XC3   )) DEALLOCATE(XC3   )
IF (ASSOCIATED(XC4B  )) DEALLOCATE(XC4B  )
IF (ASSOCIATED(XACOEF)) DEALLOCATE(XACOEF)
IF (ASSOCIATED(XPCOEF)) DEALLOCATE(XPCOEF)
IF (ASSOCIATED(XC4REF)) DEALLOCATE(XC4REF)
IF (ASSOCIATED(XCONDSAT)) DEALLOCATE(XCONDSAT)
IF (ASSOCIATED(XMPOTSAT)) DEALLOCATE(XMPOTSAT)
IF (ASSOCIATED(XALBNIR_DRY)) DEALLOCATE(XALBNIR_DRY)
IF (ASSOCIATED(XALBVIS_DRY)) DEALLOCATE(XALBVIS_DRY)
IF (ASSOCIATED(XALBUV_DRY )) DEALLOCATE(XALBUV_DRY )
IF (ASSOCIATED(XALBNIR_WET)) DEALLOCATE(XALBNIR_WET)
IF (ASSOCIATED(XALBVIS_WET)) DEALLOCATE(XALBVIS_WET)
IF (ASSOCIATED(XALBUV_WET )) DEALLOCATE(XALBUV_WET )
IF (ASSOCIATED(XABC)) DEALLOCATE(XABC)
IF (ASSOCIATED(XPOI)) DEALLOCATE(XPOI)
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XDEP))      DEALLOCATE(XDEP)
IF(ASSOCIATED(CCH_NAMES)) DEALLOCATE(CCH_NAMES)
IF(ASSOCIATED(CSV))       DEALLOCATE(CSV)
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XTI_MIN))      DEALLOCATE(XTI_MIN)
IF(ASSOCIATED(XTI_MAX))      DEALLOCATE(XTI_MAX)
IF(ASSOCIATED(XTI_MEAN))     DEALLOCATE(XTI_MEAN)
IF(ASSOCIATED(XTI_STD))      DEALLOCATE(XTI_STD)
IF(ASSOCIATED(XTI_SKEW))     DEALLOCATE(XTI_SKEW)
IF(ASSOCIATED(XTAB_FSAT))    DEALLOCATE(XTAB_FSAT)
IF(ASSOCIATED(XTAB_WTOP))    DEALLOCATE(XTAB_WTOP)
IF(ASSOCIATED(XMUF))         DEALLOCATE(XMUF)
IF(ASSOCIATED(XFSAT))        DEALLOCATE(XFSAT)
IF(ASSOCIATED(XD_ICE))       DEALLOCATE(XD_ICE)
IF(ASSOCIATED(XKSAT_ICE))    DEALLOCATE(XKSAT_ICE)
IF(ASSOCIATED(XFRACSOC))     DEALLOCATE(XFRACSOC)
!
IF(ASSOCIATED(XFFLOOD))      DEALLOCATE(XFFLOOD)
IF(ASSOCIATED(XPIFLOOD))     DEALLOCATE(XPIFLOOD)
IF(ASSOCIATED(XZ0_FLOOD))    DEALLOCATE(XZ0_FLOOD)
!
IF(ASSOCIATED(XPSNG))        DEALLOCATE(XPSNG)
IF(ASSOCIATED(XPSNV))        DEALLOCATE(XPSNV)
IF(ASSOCIATED(XPSNV_A))      DEALLOCATE(XPSNV_A)
IF(ASSOCIATED(XPSN))         DEALLOCATE(XPSN)
IF(ASSOCIATED(XDIR_ALB_WITH_SNOW))    DEALLOCATE(XDIR_ALB_WITH_SNOW)
IF(ASSOCIATED(XSCA_ALB_WITH_SNOW))    DEALLOCATE(XSCA_ALB_WITH_SNOW)
IF(ASSOCIATED(XFFG))         DEALLOCATE(XFFG)
IF(ASSOCIATED(XFFV))         DEALLOCATE(XFFV)
IF(ASSOCIATED(XFF))          DEALLOCATE(XFF)
IF(ASSOCIATED(XFFROZEN))     DEALLOCATE(XFFROZEN)
IF(ASSOCIATED(XALBF))        DEALLOCATE(XALBF)
IF(ASSOCIATED(XEMISF))       DEALLOCATE(XEMISF)
!-------------------------------------------------------------------------------------
IF(ASSOCIATED(XCPL_EFLOOD))  DEALLOCATE(XCPL_EFLOOD)
IF(ASSOCIATED(XCPL_PFLOOD))  DEALLOCATE(XCPL_PFLOOD)
IF(ASSOCIATED(XCPL_IFLOOD))  DEALLOCATE(XCPL_IFLOOD)
IF(ASSOCIATED(XCPL_DRAIN))   DEALLOCATE(XCPL_DRAIN)
IF(ASSOCIATED(XCPL_RUNOFF))  DEALLOCATE(XCPL_RUNOFF)
!-------------------------------------------------------------------------------------
IF(ASSOCIATED(XICE_STO))     DEALLOCATE(XICE_STO)
IF(ASSOCIATED(XCPL_ICEFLUX)) DEALLOCATE(XCPL_ICEFLUX)
!-------------------------------------------------------------------------------------
IF(ASSOCIATED(XPAR_VEGTYPE    )) DEALLOCATE(XPAR_VEGTYPE    )
IF(ASSOCIATED(XPAR_LAI        )) DEALLOCATE(XPAR_LAI        )
IF(ASSOCIATED(XPAR_H_TREE     )) DEALLOCATE(XPAR_H_TREE     )
IF(ASSOCIATED(XPAR_DG         )) DEALLOCATE(XPAR_DG         )
IF(ASSOCIATED(XPAR_ROOTFRAC   )) DEALLOCATE(XPAR_ROOTFRAC   )
IF(ASSOCIATED(XPAR_VEG        )) DEALLOCATE(XPAR_VEG        )
IF(ASSOCIATED(XPAR_Z0         )) DEALLOCATE(XPAR_Z0         )
IF(ASSOCIATED(XPAR_EMIS       )) DEALLOCATE(XPAR_EMIS       )
IF(ASSOCIATED(XPAR_DICE       )) DEALLOCATE(XPAR_DICE       )
IF(ASSOCIATED(XPAR_RSMIN      )) DEALLOCATE(XPAR_RSMIN      )
IF(ASSOCIATED(XPAR_GAMMA      )) DEALLOCATE(XPAR_GAMMA      )
IF(ASSOCIATED(XPAR_WRMAX_CF   )) DEALLOCATE(XPAR_WRMAX_CF   )
IF(ASSOCIATED(XPAR_RGL        )) DEALLOCATE(XPAR_RGL        )
IF(ASSOCIATED(XPAR_CV         )) DEALLOCATE(XPAR_CV         )
IF(ASSOCIATED(XPAR_Z0_O_Z0H   )) DEALLOCATE(XPAR_Z0_O_Z0H   )
IF(ASSOCIATED(XPAR_ALBNIR_VEG )) DEALLOCATE(XPAR_ALBNIR_VEG )
IF(ASSOCIATED(XPAR_ALBVIS_VEG )) DEALLOCATE(XPAR_ALBVIS_VEG )
IF(ASSOCIATED(XPAR_ALBUV_VEG  )) DEALLOCATE(XPAR_ALBUV_VEG  )
IF(ASSOCIATED(XPAR_ALBNIR_SOIL)) DEALLOCATE(XPAR_ALBNIR_SOIL)
IF(ASSOCIATED(XPAR_ALBVIS_SOIL)) DEALLOCATE(XPAR_ALBVIS_SOIL)
IF(ASSOCIATED(XPAR_ALBUV_SOIL )) DEALLOCATE(XPAR_ALBUV_SOIL )
IF(ASSOCIATED(XPAR_GMES       )) DEALLOCATE(XPAR_GMES       )
IF(ASSOCIATED(XPAR_BSLAI      )) DEALLOCATE(XPAR_BSLAI      )
IF(ASSOCIATED(XPAR_SEFOLD     )) DEALLOCATE(XPAR_SEFOLD     )
IF(ASSOCIATED(XPAR_GC         )) DEALLOCATE(XPAR_GC         )
IF(ASSOCIATED(XPAR_DMAX       )) DEALLOCATE(XPAR_DMAX       )
IF(ASSOCIATED(XPAR_RE25       )) DEALLOCATE(XPAR_RE25       )
IF(ASSOCIATED(XPAR_LAIMIN     )) DEALLOCATE(XPAR_LAIMIN     )
IF(ASSOCIATED(XPAR_F2I        )) DEALLOCATE(XPAR_F2I        )
IF(ASSOCIATED(XPAR_CE_NITRO   )) DEALLOCATE(XPAR_CE_NITRO   )
IF(ASSOCIATED(XPAR_CF_NITRO   )) DEALLOCATE(XPAR_CF_NITRO   )
IF(ASSOCIATED(XPAR_CNA_NITRO  )) DEALLOCATE(XPAR_CNA_NITRO  )
IF(ASSOCIATED(LPAR_STRESS     )) DEALLOCATE(LPAR_STRESS     )
IF(ASSOCIATED(XPAR_IRRIG      )) DEALLOCATE(XPAR_IRRIG      )
IF(ASSOCIATED(XPAR_WATSUP     )) DEALLOCATE(XPAR_WATSUP     )
!-------------------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('DEALLOC_ISBA_N',1,ZHOOK_HANDLE)
!-------------------------------------------------------------------------------------
!
END SUBROUTINE DEALLOC_ISBA_n
