!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
SUBROUTINE PACK_DIAG_PATCH_n(KSIZE,KSW)
!##############################################
!
!!****  *PACK_DIAG_PATCH_n* - packs ISBA diagnostics
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     V. Masson 
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      Modified    10/2004 by P. Le Moigne: Halstead coefficient
!!      Modified    10/2005 by P. Le Moigne: Allocation (not EBA case)
!!      Modified       2008 by B. Decharme : Allocation for the floodplains
!!      Modified      04-09 by A.L. Gibelin : Add carbon diagnostics
!!
!!------------------------------------------------------------------
!
!
USE MODD_ISBA_n,            ONLY : TSNOW, CPHOTO, LTR_ML, NGROUND_LAYER, XABC,  &
                                   LGLACIER
USE MODD_DIAG_ISBA_n,       ONLY : N2M
USE MODD_DIAG_MISC_ISBA_n,  ONLY : LSURF_MISC_BUDGET
!
USE MODD_DIAG_EVAP_ISBA_n,  ONLY : LWATER_BUDGET
!
USE MODD_PACK_DIAG_ISBA, ONLY :   XP_RNSNOW, XP_HSNOW, XP_HPSNOW, XP_SMELTFLUX, &
                                  XP_GFLUXSNOW, XP_USTARSNOW,                   &
                                  XP_GRNDFLUX, XP_SRSFC, XP_RRSFC, XP_LESL,     &
                                  XP_CDSNOW, XP_CHSNOW, XP_SNOWTEMP,            &
                                  XP_SNOWLIQ, XP_SNOWDZ, XP_SNOWHMASS,          &
                                  XP_RN_ISBA, XP_H_ISBA, XP_LEG_ISBA,           &
                                  XP_LEGI_ISBA, XP_LEV_ISBA, XP_LETR_ISBA,      &
                                  XP_USTAR_ISBA, XP_LER_ISBA,                   &
                                  XP_LE_ISBA, XP_GFLUX_ISBA, XP_MELTADV,        &
                                  XP_LEI_ISBA, XP_IACAN,                        &
                                  XP_CH, XP_CD, XP_CDN, XP_RI, XP_HU, XP_HUG,   &
                                  XP_RN, XP_H, XP_LEI, XP_LEG,                  &
                                  XP_LEGI, XP_LEV,                              &
                                  XP_LES, XP_LER, XP_LETR, XP_EVAP, XP_GFLUX,   &
                                  XP_RESTORE, XP_DRAIN, XP_RUNOFF, XP_MELT,     &
                                  XP_SNOWFREE_ALB, XP_Z0_WITH_SNOW,             &
                                  XP_Z0H_WITH_SNOW, XP_Z0EFF,                   &
                                  XP_CG, XP_C1, XP_C2, XP_WGEQ, XP_CT, XP_RS,   &
                                  XP_T2M, XP_Q2M, XP_HU2M,                      &
                                  XP_ZON10M, XP_MER10M, XP_HV,                  &
                                  XP_SNOWFREE_ALB_VEG, XP_SNOWFREE_ALB_SOIL,    &
                                  XP_SWI, XP_TSWI, XP_QS, XP_CE,                &
                                  XP_TWSNOW, XP_TDSNOW,                         &
                                  XP_SWD, XP_SWU, XP_SWBD, XP_SWBU,             &
                                  XP_LWD, XP_LWU, XP_FMU, XP_FMV, XP_HORT,      &
                                  XP_DRIP, XP_ALBT, XP_IFLOOD, XP_PFLOOD,       &
                                  XP_LE_FLOOD, XP_LEI_FLOOD, XP_ICEFLUX,        &
                                  XP_RRVEG, XP_TS, XP_TSRAD,                    &
                                  XP_GPP, XP_RESP_AUTO, XP_RESP_ECO,            &
                                  XP_FAPAR, XP_FAPIR, XP_FAPAR_BS, XP_FAPIR_BS, &
                                  XP_IRRIG_FLUX, XP_DWG, XP_DWGI, XP_DWR,       &
                                  XP_DSWE, XP_WATBUD,                           &
                                  XBLOCK_SIMPLE, XBLOCK_GROUND, XBLOCK_SNOW,    &
                                  XBLOCK_KSW, XBLOCK_ABC, XBLOCK_0, XBLOCK_00,  &
                                  NSIZE_SIMPLE, NSIZE_GROUND, NSIZE_SNOW,       &
                                  NSIZE_KSW, NSIZE_ABC, NSIZE_0, NSIZE_00

!
USE MODI_ABOR1_SFX
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
INTEGER, INTENT(IN)               :: KSIZE, KSW
!
INTEGER :: ISIZE_SIMPLE, ISIZE_GROUND, ISIZE_SNOW, ISIZE_KSW, &
           ISIZE_ABC, ISIZE_0, ISIZE_00
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('PACK_DIAG_PATCH_N',0,ZHOOK_HANDLE)
!
! Packed surface module variables:
!
ALLOCATE(XBLOCK_SIMPLE(KSIZE,NSIZE_SIMPLE))
ALLOCATE(XBLOCK_GROUND(KSIZE,NGROUND_LAYER,NSIZE_GROUND))
ALLOCATE(XBLOCK_SNOW(KSIZE,TSNOW%NLAYER,NSIZE_SNOW))
ALLOCATE(XBLOCK_KSW(KSIZE,KSW,NSIZE_KSW))
ALLOCATE(XBLOCK_ABC(KSIZE,SIZE(XABC),NSIZE_ABC))
ALLOCATE(XBLOCK_0(0,NSIZE_0))
ALLOCATE(XBLOCK_00(0,0,NSIZE_00))
!
ISIZE_SIMPLE=0
ISIZE_GROUND=0
ISIZE_SNOW=0
ISIZE_KSW=0
ISIZE_ABC=0
ISIZE_0=0
ISIZE_00=0
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CH          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CE          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CD          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CDN         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RI          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HU          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HUG         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBT        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RN          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_H           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LEI         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LEG         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LEGI        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LEV         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LES         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LER         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LETR        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_GFLUX       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_EVAP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RESTORE     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_DRAIN       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RUNOFF      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_MELT        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_MELTADV     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SRSFC       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RRSFC       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SNOWFREE_ALB=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HORT      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_DRIP      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RRVEG     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_IRRIG_FLUX=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_KSW = ISIZE_KSW + 1
XP_SWBD       => XBLOCK_KSW(:,:,ISIZE_KSW)
ISIZE_KSW = ISIZE_KSW + 1
XP_SWBU       => XBLOCK_KSW(:,:,ISIZE_KSW)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SWD         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SWU         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LWD         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LWU         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FMU         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FMV         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0_WITH_SNOW => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0H_WITH_SNOW=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0EFF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CG          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_C1          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_C2          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_WGEQ        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CT          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RS          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HV          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_QS          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_TS            => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_TSRAD         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RESP_AUTO    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RESP_ECO     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_GPP          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_IFLOOD   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_PFLOOD   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LE_FLOOD => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LEI_FLOOD=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
IF (TSNOW%SCHEME=='3-L' .OR. TSNOW%SCHEME=='CRO') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_RNSNOW    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_HSNOW     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_HPSNOW    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_SMELTFLUX => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_GFLUXSNOW => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_USTARSNOW => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_GRNDFLUX  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LESL      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_CDSNOW    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_CHSNOW    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_SNOWHMASS => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_RN_ISBA   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_H_ISBA    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LEG_ISBA  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LEGI_ISBA => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LEV_ISBA  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LETR_ISBA => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_USTAR_ISBA=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LER_ISBA  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LE_ISBA   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LEI_ISBA  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_GFLUX_ISBA=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SNOW = ISIZE_SNOW + 1
  XP_SNOWLIQ   => XBLOCK_SNOW(:,:,ISIZE_SNOW)
  ISIZE_SNOW = ISIZE_SNOW + 1
  XP_SNOWDZ    => XBLOCK_SNOW(:,:,ISIZE_SNOW)  
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_RNSNOW    => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_HSNOW     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_HPSNOW    => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_SMELTFLUX => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GFLUXSNOW => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_USTARSNOW => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GRNDFLUX  => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LESL      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_CDSNOW    => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_CHSNOW    => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_SNOWHMASS => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_RN_ISBA   => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_H_ISBA    => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LEG_ISBA  => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LEGI_ISBA => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LEV_ISBA  => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LETR_ISBA => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_USTAR_ISBA=> XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LER_ISBA  => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LE_ISBA   => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LEI_ISBA  => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GFLUX_ISBA=> XBLOCK_0(:,ISIZE_0)
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWLIQ   => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWDZ    => XBLOCK_00(:,:,ISIZE_00)
END IF
!
IF(TSNOW%SCHEME/='EBA') THEN
  ISIZE_SNOW = ISIZE_SNOW + 1
  XP_SNOWTEMP    => XBLOCK_SNOW(:,:,ISIZE_SNOW)
ELSE
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWTEMP    => XBLOCK_00(:,:,ISIZE_00)
ENDIF
!
IF(TSNOW%SCHEME=='EBA') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_SNOWFREE_ALB_VEG=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_SNOWFREE_ALB_SOIL=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_SNOWFREE_ALB_VEG=> XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_SNOWFREE_ALB_SOIL=> XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (LTR_ML) THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPAR => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPIR => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPAR_BS => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPIR_BS => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE 
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPAR => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPIR => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPAR_BS => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPIR_BS => XBLOCK_0(:,ISIZE_0)
END IF
!
IF (CPHOTO/='NON') THEN
  ISIZE_ABC = ISIZE_ABC + 1
  XP_IACAN => XBLOCK_ABC(:,:,ISIZE_ABC)
ELSE
  ISIZE_00 = ISIZE_00 + 1
  XP_IACAN => XBLOCK_00(:,:,ISIZE_00)
END IF
!
IF (N2M>=1) THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_T2M         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_Q2M         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_HU2M        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_ZON10M      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_MER10M      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_T2M         => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_Q2M         => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_HU2M        => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ZON10M      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_MER10M      => XBLOCK_0(:,ISIZE_0)
END IF
!
IF (LSURF_MISC_BUDGET) THEN
  ISIZE_GROUND = ISIZE_GROUND + 1
  XP_SWI          => XBLOCK_GROUND(:,:,ISIZE_GROUND)
  ISIZE_GROUND = ISIZE_GROUND + 1
  XP_TSWI         => XBLOCK_GROUND(:,:,ISIZE_GROUND)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_TWSNOW       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_TDSNOW       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_00 = ISIZE_00 + 1
  XP_SWI          => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_00 = ISIZE_00 + 1
  XP_TSWI         => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_0 = ISIZE_0 + 1
  XP_TWSNOW       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_TDSNOW       => XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF(LGLACIER)THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_ICEFLUX=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_ICEFLUX=> XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF(LWATER_BUDGET)THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_DWG=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_DWGI=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_DWR=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_DSWE=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_WATBUD=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)  
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_DWG=> XBLOCK_0(:,ISIZE_0) 
  ISIZE_0 = ISIZE_0 + 1
  XP_DWGI=> XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_DWR=> XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_DSWE=> XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_WATBUD=> XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (ISIZE_SIMPLE.GT.NSIZE_SIMPLE) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_SIMPLE / NUMBER OF FIELDS")
IF (ISIZE_GROUND.GT.NSIZE_GROUND) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_GROUND / NUMBER OF FIELDS")
IF (ISIZE_SNOW.GT.NSIZE_SNOW) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_SNOW / NUMBER OF FIELDS")
IF (ISIZE_KSW.GT.NSIZE_KSW) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_KSW / NUMBER OF FIELDS")
IF (ISIZE_ABC.GT.NSIZE_ABC) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_3 / NUMBER OF FIELDS")
IF (ISIZE_0.GT.NSIZE_0) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_0 / NUMBER OF FIELDS")
IF (ISIZE_00.GT.NSIZE_00) & 
  CALL ABOR1_SFX("PACK_DIAG_PATCH_n: PROBLEM DEFINING SIZE_00 / NUMBER OF FIELDS") 
!
IF (LHOOK) CALL DR_HOOK('PACK_DIAG_PATCH_N',1,ZHOOK_HANDLE)
!------------------------------------------------------------------------
!
END SUBROUTINE PACK_DIAG_PATCH_n
